#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/* TAGLI PREVISTI PER L'EURO (INTERI) */
#define T500 500
#define T200 200
#define T100 100
#define T50  50
#define T20  20
#define T10  10
#define T5   5
#define T2   2
#define T1   1

/* TAGLI PREVISTI PER L'EURO (CENTESIMI) */
#define T050 50
#define T020 20
#define T010 10
#define T005 5
#define T002 2
#define T001 1

/* calcolo del minimo numero di tagli secondo la valuta corrente EURO */
/* con la quale  possibile pagare un certo stipendio immesso in input */
int main(int argc, char *argv[])
{
int n500,n200,n100,n50,n20,n10,n5,n2,n1,n050,n020,n010,n005,n002,n001;
float stipendio;
int stipendioA, stipendioInt, stipendioDec;
int i, j, lung, lungInt;
char appoStipendio[11];            // MAX 7 cifre int + '.' + 2 cifre dec + '\0'
char appoIntS1[8],appoIntS[8];     // MAX 7 cifre + '\0'
// Vedi che succede se scrivi char appoDecS[2]! sapresti spiegare l'errore? */
char appoDecS[3];                  // MAX 2 cifre + '\0'
char c;    

/* inizializzazione variabili che contano i tagli delle monete */
n500 = 0;
n200 = 0;
n100 = 0;
n50 = 0;
n20 = 0;
n10 = 0;
n5 = 0;
n2 = 0;
n1 = 0;

n050 = 0;
n020 = 0;
n010 = 0;
n005 = 0;
n002 = 0;
n001 = 0;

/* impostazione titolo della finestra del programma */
system("TITLE SUDDIVISIONE IMPORTO IN TAGLI EURO (CIFRA CON DECIMALI)");

/* impostazione colore di sfondo e colore testo */
system("COLOR 1f");

/* lettura stipendio da partizionare */    
printf("Inserisci la cifra da suddividere : ");
fflush(stdin);
scanf("%f",&stipendio);

/* converto il numero reale con il punto decimale in una stringa */
/* arrotondando con criteri matematici la parte decimale */
sprintf(appoStipendio, "%.2f", stipendio);
lung = strlen (appoStipendio);

/* estraggo la parte intera della cifra immessa */
i = 0;
while (appoStipendio[i] != '.')
   {
   appoIntS[i] = appoStipendio[i];
   i++;  
   }
appoIntS[i] = '\0';
 
 /* estraggo la parte decimale della cifra immessa */
lungInt = strlen (appoIntS);
i = lungInt +1;
j = 0;
while (appoStipendio[i] != '\0')
   {
   appoDecS[j] = appoStipendio[i];
   j++;
   i++;  
   }
appoDecS[j] = '\0';

/* visualizzo parte intera e parte decimale della cifra immessa */
printf("\nPARTE INTERA della cifra immessa : "); 
printf("%s\n", appoIntS);
printf("PARTE DECIMALE della cifra immessa : "); 
printf("%s\n\n", appoDecS);

/* conversioni di parte intera e parte decimale da stringhe a numeri interi */
stipendioInt = atoi(appoIntS);
stipendioDec = atoi(appoDecS);

/* CONVERSIONE PARTE INTERA */
stipendioA = stipendioInt;

/* ciclo secondo il numero deio tagli previsti per lo stipendio */
for(i=1;i<=9;i++)
   {
   /* il numero di tagli occorrenti  dato dal quoziente della          */
   /* divisione intera tra lo stipendio attuale ed il valore del taglio */
   /* mentre la parte di stipendio residua  il resto di tale divisione */   
   switch(i)
      {
      case 1:
         {  
         n500 = stipendioA/T500;
         stipendioA = stipendioA%T500;    
         break;
         }                     
      case 2:
         {
         n200 = stipendioA/T200;
         stipendioA = stipendioA%T200;                 
         break;
         }   
      case 3:
         {
         n100 = stipendioA/T100;
         stipendioA = stipendioA%T100;                 
         break;
         }   
      case 4:
         {
         n50 = stipendioA/T50;
         stipendioA = stipendioA%T50;                 
         break;
         }   
      case 5:
         {
         n20 = stipendioA/T20;
         stipendioA = stipendioA%T20;                 
         break;
         }   
      case 6:
         {
         n10 = stipendioA/T10;
         stipendioA = stipendioA%T10;              
         break;
         }   
      case 7:
         {
         n5 = stipendioA/T5;
         stipendioA = stipendioA%T5; 
         break;
         }
      case 8:
         {
         n2 = stipendioA/T2;
         stipendioA = stipendioA%T2; 
         break;
         }   
      case 9:
         {
         n1 = stipendioA/T1;
         stipendioA = stipendioA%T1;              
         break;
         }                                                                                 
      }          
   }              

/* visualizzo il numero di tagli necessari */
printf("SUDDIVISIONE TAGLI EURO PARTE INTERA\n");
printf("%5d da %3d\n%5d da %3d\n%5d da %3d\n%5d da %3d\n%5d da %3d\n%5d da %3d\n%5d da %3d\n%5d da %3d\n%5d da %3d\n\n", n500,T500,n200,T200,n100,T100,n50,T50,n20,T20,n10,T10,n5,T5,n2,T2,n1,T1);
    

/* CONVERSIONE PARTE DECIMALE */
stipendioA = stipendioDec;

/* ciclo secondo il numero deio tagli previsti per lo stipendio */
for(i=1;i<=6;i++)
   {
   /* il numero di tagli occorrenti  dato dal quoziente della          */
   /* divisione intera tra lo stipendio attuale ed il valore del taglio */
   /* mentre la parte di stipendio residua  il resto di tale divisione */   
   switch(i)
      {
      case 1:
         {  
         n050 = stipendioA/T050;
         stipendioA = stipendioA%T050;    
         break;
         }                     
      case 2:
         {
         n020 = stipendioA/T020;
         stipendioA = stipendioA%T020;                 
         break;
         }   
      case 3:
         {
         n010 = stipendioA/T010;
         stipendioA = stipendioA%T010;                 
         break;
         }   
      case 4:
         {
         n005 = stipendioA/T005;
         stipendioA = stipendioA%T005;                 
         break;
         }   
      case 5:
         {
         n002 = stipendioA/T002;
         stipendioA = stipendioA%T002;                 
         break;
         }   
      case 6:
         {
         n001 = stipendioA/T001;
         stipendioA = stipendioA%T001;              
         break;
         }                                                                      
      }          
   }              

/* visualizzo il numero di tagli necessari */
printf("SUDDIVISIONE TAGLI EURO PARTE DECIMALE\n");
printf("%2d da 0.50\n%2d da 0.20\n%2d da 0.10\n%2d da 0.05\n%2d da 0.02\n%2d da 0.01\n\n", n050,n020,n010,n005,n002,n001);

  
system("PAUSE");	
return 0;
}
